package com.liang.controller;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.liang.common.annotation.LogAround;
import com.liang.common.base.BaseController;
import com.liang.entity.BaseArea;
import com.liang.service.BaseAreaService;
import io.swagger.annotations.ApiOperation;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * (BaseArea)表控制层
 *
 * @author makejava
 * @since 2023-02-15 23:13:08
 */
@Controller
@RequestMapping("baseArea")
public class BaseAreaController extends BaseController {
    /**
     * 服务对象
     */
    @Resource
    private BaseAreaService baseAreaService;

    /**
     * 分页查询
     *
     * @param baseArea    筛选条件
     * @param pageRequest 分页对象
     * @return 查询结果
     */
    @GetMapping
    public ResponseEntity<Page<BaseArea>> queryByPage(BaseArea baseArea, PageRequest pageRequest) {
        return ResponseEntity.ok(this.baseAreaService.queryByPage(baseArea, pageRequest));
    }

    /**
     * 通过主键查询单条数据
     *
     * @param id 主键
     * @return 单条数据
     */
    @GetMapping("{id}")
    public ResponseEntity<BaseArea> queryById(@PathVariable("id") Integer id) {
        return ResponseEntity.ok(this.baseAreaService.queryById(id));
    }

    /**
     * 新增数据
     *
     * @param baseArea 实体
     * @return 新增结果
     */
    @PostMapping
    public ResponseEntity<BaseArea> add(BaseArea baseArea) {
        return ResponseEntity.ok(this.baseAreaService.insert(baseArea));
    }

    /**
     * 编辑数据
     *
     * @param baseArea 实体
     * @return 编辑结果
     */
    @PutMapping
    public ResponseEntity<BaseArea> edit(BaseArea baseArea) {
        return ResponseEntity.ok(this.baseAreaService.update(baseArea));
    }

    /**
     * 删除数据
     *
     * @param id 主键
     * @return 删除是否成功
     */
    @DeleteMapping
    public ResponseEntity<Boolean> deleteById(Integer id) {
        return ResponseEntity.ok(this.baseAreaService.deleteById(id));
    }

    @ApiOperation(value = "页面初始化", notes = "页面初始化")
    @RequestMapping(value = "/init", method = RequestMethod.GET)
    public String init() {
        return "basearea/list";
    }

    @LogAround("数据分页查询")
    @ApiOperation(value = "数据分页查询", notes = "数据分页查询")
    @ResponseBody
    @RequestMapping(value = "/list", method = RequestMethod.GET)
    public Object list() {

        List<BaseArea> list = baseAreaService.queryAll();

        Map<String, Object> resultMap = new HashMap<>();
        resultMap.put("code", 0);
        resultMap.put("msg", "");
        resultMap.put("count", list.size());
        resultMap.put("data", list);

        return resultMap;
    }

    @ResponseBody
    @RequestMapping(value = "/gjlist", method = RequestMethod.GET)
    public Object gjlist(@RequestParam("page") Integer pageNum,
                         @RequestParam("limit") Integer pageSize,
                         @RequestParam(required = false, defaultValue = "", value = "mc") String mc) {
        PageHelper.startPage(pageNum, pageSize);

        Map<String, String> paraMap = new HashMap<>();
        paraMap.put("mc", mc);
        List<BaseArea> list = baseAreaService.getCountryList(paraMap);

        PageInfo<BaseArea> pageinfo = new PageInfo<>(list);
        // 取出查询结果
        List<BaseArea> rows = pageinfo.getList();
        int total = (int) pageinfo.getTotal();

        Map<String, Object> resultMap = new HashMap<>();
        resultMap.put("code", 0);
        resultMap.put("msg", "");
        resultMap.put("count", total);
        resultMap.put("data", list);

        return resultMap;
    }
}

